
#include <set>
#include <ctime>
#include <cstdlib>
#include <iostream>
#include <algorithm>
using namespace std;

const int MAXN = 32;

int n;
int a[MAXN];

inline int random(int a, int b) {
	return a + rand() % (b - a + 1);
}

void read(bool whether = false) {
	if (whether) {
		cin >> n;
		for (int i = 0; i < n; ++i)
			cin >> a[i];
	} else {
		n = random(2, 10);
		cout << n << ": ";
		for (int i = 0; i < n; ++i)
			a[i] = random(0, 9);
	}
}

int solve() {
	static long long stk[MAXN];
	
	int k = n - 1;
	set <long long> all;
	for (int m = 0; m < (1 << k); ++m) {
		stk[0] = a[0];
		int sp = 1; 
		for (int i = 0; i < k; ++i)
			if (((m >> i) & 1) > 0) {
				stk[sp - 1] *= a[i + 1];
			} else {
				stk[sp] = a[i + 1];
				++sp;
			}
		set <long long> cur;
		cur.insert(stk[0]);
		for (int i = 1; i < sp; ++i) {
			set <long long> nxt;
			for (typeof(cur.begin()) it = cur.begin(); it != cur.end(); ++it) {
				nxt.insert(*it + stk[i]);
				nxt.insert(*it - stk[i]);
			}
			cur = nxt;
		}
		for (typeof(cur.begin()) it = cur.begin(); it != cur.end(); ++it)
			all.insert(*it);
	}
	return all.size();
}

#define foreach(it, c) for (__typeof(c.begin()) it = c.begin(); it != c.end(); ++it)

int solve2() {
//	clock_t start = clock();
	set <pair <long long, long long> > cur;
	cur.insert(make_pair(0, a[0]));
	for (int i = 1; i < n; ++i) {
		set <pair <long long, long long> > nxt;
		foreach (it, cur) {
			long long result = it->first;
			long long last = it->second;
			nxt.insert(make_pair(result, last * a[i])); // if we multiply
			nxt.insert(make_pair(result + last, a[i])); // if we add
			nxt.insert(make_pair(result + last, -a[i])); // if we subtract
		}
		cur = nxt;
	}
	set <long long> res;
	foreach (it, cur)
		res.insert(it->first + it->second);
//	clock_t end = clock();
//	cout << (0.0 + end - start) / CLOCKS_PER_SEC << endl;
	return res.size();
}

void test() {
	while (true) {
		read();
		int x = solve();
		int y = solve2();
		assert(x == y);
		cout << x << " " << y << endl;
		cout << endl;
	}
}

int main() {
//	test();
	read(true);
	cout << solve2() << endl;
	return 0;
}
