
#include <vector>
#include <iostream>
using namespace std;

const int MAXN = 805;
const int BASE = 1000000000;

struct bigint {
	vector <int> digs;
	
	bigint(int v = 0) {
		clear();
		if (v > 0)
			digs.push_back(v);
	}
	
	inline void add(bigint &rhs) {
		int carry = 0;
		for (int i = 0; i < (int) digs.size() || i < (int) rhs.digs.size() || carry > 0; ++i) {
			if (i >= (int) digs.size())
				digs.push_back(0);
			carry += digs[i];
			if (i < (int) rhs.digs.size())
				carry += rhs.digs[i];
			digs[i] = carry;
			if (carry >= BASE) {
				digs[i] -= BASE;
				carry = 1;
			} else
				carry = 0;
		}
	}
	
	inline void clear() {
		digs.clear();
	}
	
	inline void print() {
		int i = digs.size() - 1;
		while (i > 0 && digs[i] == 0)
			--i;
		printf("%d", digs[i]);
		for (--i; i >= 0; --i)
			printf("%09d", digs[i]);
		puts("");
	}
};

bigint ONE(1);

bigint dp[2][MAXN];

int main() {
	int N, K;
	cin >> N >> K;
	for (int k = 0; k <= K; ++k) {
		for (int n = 0; n <= N; ++n)
			if (k == 0) {
				if (n == 0)
					dp[k & 1][n].add(ONE);
			} else {
				dp[k & 1][n].clear();
				if (n - k >= 0)
					dp[k & 1][n].add(dp[k & 1][n - k]);
				if (k - 1 >= 0)
					dp[k & 1][n].add(dp[(k - 1) & 1][n]);
			}
	}
	dp[K & 1][N - K].print();
	return 0;
}
