#include <cstdio>

const int MAXN = 801;
const int base = 1000000000;

struct bignum {
    int a[4];
    
    bignum () { 
        int i;
        for (i = 0; i < 4; i++) a[i] = 0;
    }
    
    void operator = ( int x ) {
        a[0] = x;
    }
    
    void add ( bignum &b ) {
        int i;
        int x;
        
        for (i = 0; i < 4; i++) {
            x = a[i] + b.a[i];
            a[i] = x % base;
            a[i + 1] += x / base;
        }
    }
    
    void print() {
        int i;
        
        for (i = 3; i > 0; i--)
            if ( a[i] )
                break;
                
        printf ( "%d" , a[i] );
        for (i--; i >= 0; i--)
            printf ( "%.9d" , a[i] );
        printf ( "\n" );
    }
};

int n , k;
bignum dp[MAXN][MAXN];

void read() {
    scanf ( "%d%d" , &n , &k );
}

void solve() {
    int i , j , d;
    
    dp[0][0] = 1;
    
    for (i = 1; i <= n; i++)
        for (j = i; j <= n; j++)
            for (d = 0; d < k; d++)
                dp[j][d + 1].add ( dp[j - i][d] );
    
    dp[n][k].print();
}

int main() {
    read();
    if ( k >= (n + 1) / 2 ) {
        int s = n - k;
        n = (n - k) * 2;
        k = n - s;
    }
    solve();
    
    return 0;
}
