/*
TASK: expr
LANG: C++
*/
#include <iostream>
#include <algorithm>
using namespace std;

int nodes=0;
int dig[20],N;
char signs[20];
int signN;

struct Node{
	long res;
	Node *next;
} *root;

void makeBegin(int res){
	root = new Node;
	root->res= res;
	root->next = NULL;
	nodes++;
}
void addNew(int res){
	if(!root){
		makeBegin(res);
	}else{
		Node * last;
		Node * current = root;
		do{
			if(current->res == res)
				return;
			else{
				last = current;
				current = current->next;
			}
		}while(current);
		last->next = new Node;
		last->next->res = res;
		last->next->next = NULL;
		nodes++;
	}
}

void makeStr(char * s,int power,int plus,int minus){
	int i,k=0;
	for(i=0;i<power;i++){
		s[k++] = '*';
	}
	for(i=0;i<plus;i++){
		s[k++] = '+';
	}
	for(i=0;i<minus;i++){
		s[k++] = '-';
	}
	s[k] = 0;
}

long compute(int wh=0,int sign=0){
	int i,j,product=1;
	if(sign == signN-1){
		if(signs[sign] == '*'){
			return wh+1 <N ? dig[wh]*dig[wh+1] : dig[wh];
		}
		return wh+1 <N ? dig[wh]+dig[wh+1] : dig[wh];
	}
	if(signs[sign] == '*'){
		product = dig[wh]*dig[wh+1];
		for(i=wh+2,j=sign+1;signs[j] == '*' ;j++,i++){
			product *= dig[i];
		}
		if(j < signN){
			return product + compute(i,j);
		}else{
			return product;
		}
	}
	if(signs[sign+1] == '*'){
		return dig[wh] + compute(wh+1,sign+1);
	}
	return dig[wh] +  compute(wh+1,sign+1);
}

void work(int power,int plus, int minus){
	makeStr(signs,power,plus,minus);
	int n = power+plus+minus,i;
	int exit;
	do{
		for(i=0;i<n;i++){
			if(signs[i] == '-'){
				dig[i+1] = -dig[i+1];
			}
		}
		exit = compute();
		addNew(exit);
		for(i=0;i<n;i++){
			if(signs[i] == '-'){
				dig[i+1] = -dig[i+1];
			}
		}
	}while(next_permutation(signs,signs+n));
}


int main(){
	int i,j;
	cin >> N;
	for(i=0;i<N;i++){
		cin >> dig[i];
	}
	signN = N-1;
	for(i=0;i<N;i++){
		for(j=0;j<N;j++){
    		if(i+j <= signN){
					work(i,j,signN - (i+j) );
			}
		}
	}
	cout << nodes << endl;
	return 0;
}

