#include <iostream>
#include <cstdio>
using namespace std;

#define MAXN 101
#define MAXM 10001

struct edge {
 int from, to, next;
 edge() { }       
 edge(int from, int to, int next) : from(from), to(to), next(next) { }
} edges[MAXM];

int N, M, E;

int table[MAXN];

char let[116], word[16];

int DP[16][MAXN];

void add_edge(int a, int b)
{
 edges[E] = edge(a, b, table[a]);
 table[a] = E++;
}

int solve(int len, int node)
{
 if (len == strlen(word) - 1) return 1;
 
 if (DP[len][node] != -1) return DP[len][node];
 
 int ret = 0;
 
 for (int i = table[node]; i != -1; i = edges[i].next)
 {
  int real = edges[i].to;
  if (word[len + 1] == let[real])
   ret += solve(len + 1, real);
 }
 
 return DP[len][node] = ret;
}

int main()
{
 E = 0;
 memset(table, -1, sizeof(table));
 
 scanf("%d%d", &N, &M);
 scanf("%s", let);
 for (int i = 0; i < M; i++)
 {
  int a, b;
  scanf("%d%d", &a, &b); a--; b--;
  add_edge(a, b);
  if (a != b)
   add_edge(b, a);
 }
 scanf("%s", word);
 
 int ans = 0;
 
 memset(DP, -1, sizeof(DP));
 
 for (int i = 0; i < N; i++)
  if (let[i] == word[0])
   ans += solve(0, i);
 
 printf("%d\n", ans); 
 
 return 0;
}
